"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

exports.default = (0, _ramda.curryN)(2, function hammer(key, pairs) {
  if ((0, _ramda.type)(pairs) !== "Object") {
    throw new Error("hammer only works on an Object, but the second argument was a " + (0, _ramda.type)(pairs));
  }

  var onlyKey = (0, _ramda.prop)(key, pairs);
  var withoutKey = (0, _ramda.omit)(key, pairs);

  if ((0, _ramda.type)(onlyKey) !== "Object") {
    throw new Error("The hammered property " + key + " was not an Object it was a " + (0, _ramda.type)(onlyKey));
  }

  return (0, _ramda.merge)(withoutKey, onlyKey);
});